// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DICOMDecoder.pas' rev: 6.00

#ifndef DICOMDecoderHPP
#define DICOMDecoderHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Graphics.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <DICOMDictionary.hpp>	// Pascal unit
#include <DICOMDefines.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dicomdecoder
{
//-- type declarations -------------------------------------------------------
typedef tagRGBTRIPLE TRGBTripleArray[65536];

typedef tagRGBTRIPLE *pRGBTripleArray;

#pragma option push -b-
enum TFileType { DICOM30, ACRNEMA20, ACRNEMA10, UNKNOW };
#pragma option pop

#pragma option push -b-
enum TItemEndMode { WantSQEnd, WantLengthEnd };
#pragma option pop

#pragma pack(push, 4)
struct TDataSet
{
	Word Group;
	Word Element;
	char VR[2];
	unsigned Length;
	char *Value;
} ;
#pragma pack(pop)

typedef DynamicArray<TDataSet >  DICOMDecoder__2;

typedef DynamicArray<Byte >  DICOMDecoder__3;

typedef DynamicArray<DynamicArray<Byte > >  DICOMDecoder__4;

class DELPHICLASS TDICOMDecoder;
class PASCALIMPLEMENTATION TDICOMDecoder : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TFileType FileType;
	int CurrentPosition;
	Dicomdefines::_UID CurrentTransferSyntax;
	Classes::TFileStream* AStream;
	bool __fastcall IsOBOWSQUN(const char * VR);
	Word __fastcall GetValue2(void);
	unsigned __fastcall GetValue4(void);
	bool __fastcall IsExplicit(void);
	bool __fastcall IsUndefineLength(unsigned L);
	bool __fastcall Is_ItemBeginTag(Word Group, Word Element);
	bool __fastcall Is_ItemEndTag(Word Group, Word Element);
	bool __fastcall Is_ItemDelimTag(Word Group, Word Element);
	void __fastcall AddDS(const TDataSet &ADataSet);
	bool __fastcall IsTransfer(Word Group, Word Element);
	int __fastcall Locate(Word G, Word E);
	void __fastcall BACK2BYTE(void);
	void __fastcall WillReadSQItem(unsigned TheLength);
	void __fastcall GetMaxMin(void);
	void __fastcall Scale16to8(int AMin, int AMax);
	bool __fastcall IsACRNEMA10(Classes::TFileStream* TheStream);
	bool __fastcall IsACRNEMA20(Classes::TFileStream* TheStream);
	bool __fastcall IsDICOM30(Classes::TFileStream* TheStream);
	TFileType __fastcall DetermineFile(void);
	bool __fastcall IsLittleEndian(void);
	bool __fastcall Write10toDICOM3(AnsiString DICOM3FileName);
	
public:
	DynamicArray<TDataSet >  DataSets;
	int _ImageNumber;
	int _SeriesNumber;
	int _SeriesStudy;
	int _NumberOfFrames;
	int _ImageIndex;
	float _ImagePosition;
	int _CardiacNumberOfImages;
	float _SpacingBetweenSlices;
	float _SliceLocation;
	int _NumberOfSlices;
	int _NumberOfTimeSlices;
	float _SliceThickness;
	int _ReferenceImageNumber;
	Byte _FrameCount;
	Byte _FrameIndex;
	Byte _BitsAllocated;
	Byte _BitsStored;
	Byte _HighBit;
	int _Rows;
	int _Cols;
	int _Samples_Pre_Pixel;
	int _Planar;
	int _Pixel_Rep;
	AnsiString _PhotoMetric;
	double _WindowWidth;
	double _WindowCenter;
	bool _RGB;
	bool _RLE;
	bool _JPG;
	bool _ColorByPlane;
	float _RescaleIntercept;
	float _RescaleSlope;
	float _PixelSpacingX;
	int _MaxPixelValue;
	int _MinPixelValue;
	char *_NewPixelsData;
	char *_Pixelsdata;
	DynamicArray<DynamicArray<Byte > >  _PixelsDataEx;
	AnsiString _PatientName;
	AnsiString _PatientID;
	AnsiString _Sex;
	AnsiString _StudyDate;
	AnsiString _InstitutionName;
	AnsiString _StudyTime;
	AnsiString _FieldofViewDimensions;
	int _SpatialResolution;
	int _RegionLocationMinX0;
	int _RegionLocationMinY0;
	int _RegionLocationMaxX1;
	int _RegionLocationMaxY1;
	AnsiString _TriggerTime;
	AnsiString __fastcall GetLO(Word G, Word E);
	AnsiString __fastcall GetPN(Word G, Word E);
	AnsiString __fastcall GetCS(Word G, Word E);
	AnsiString __fastcall GetDA(Word G, Word E);
	AnsiString __fastcall GetUS(Word G, Word E);
	AnsiString __fastcall GetIS(Word G, Word E);
	AnsiString __fastcall GetDS(Word G, Word E);
	unsigned __fastcall GetUnsignedInteger(AnsiString a);
	int __fastcall GetInteger32(AnsiString a);
	short __fastcall GetInteger16(AnsiString a);
	float __fastcall GetFloatSingle(AnsiString a);
	double __fastcall GetFloatDouble(AnsiString a);
	char * __fastcall GetPixels(Word G, Word E);
	Dicomdefines::_UID __fastcall GetValueSS(const TDataSet &ADataSet);
	int __fastcall GetDSCount(void);
	AnsiString __fastcall GetValueAll(const TDataSet &ADataSet);
	TFileType __fastcall Read(void);
	void __fastcall GetDICOMPara(void);
	void __fastcall CreateBmp(Graphics::TBitmap* ABitmap, int AMin = 0x0, int AMax = 0x0);
	__fastcall virtual TDICOMDecoder(Classes::TComponent* AOwner);
	__fastcall virtual ~TDICOMDecoder(void);
	void __fastcall OpenFile(AnsiString TheFileName);
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint ACRNEMA10_OffSet = 0x40;
static const Shortint ACRNEMA20_OffSet = 0x0;
static const Byte DICOM30_OFFSET = 0x84;

}	/* namespace Dicomdecoder */
using namespace Dicomdecoder;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DICOMDecoder
